using System;
using System.Xml;
using System.Collections;
using Microsoft.RuleEngine;
using Microsoft.BizTalk.RuleEngineExtensions;
using System.IO;

namespace Que.BizTalk.Rules
{
	/// <summary>
	/// Console app that loads a policy from the database and executes it with 
	/// provided facts
	/// </summary>
	class RFPHost
	{
		/// <summary>
		/// The main entry point for the application.
		/// Code that is commented out is for using a PolicyTester to
		/// locate the policy in the local rule store.
		/// Active lines show how to use a deployed version and 
		/// the Rule Update Service.  Refer to the code listings in the text
		/// to see both versions.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
         try
         {
            // locate the RFP 1.1 policy in the local rules store
            //RuleSetInfo rsInfo = new RuleSetInfo("RFP", 1, 1);
            //Microsoft.BizTalk.RuleEngineExtensions.RuleSetDeploymentDriver dd = new Microsoft.BizTalk.RuleEngineExtensions.RuleSetDeploymentDriver();
            //RuleStore sqlrs;

            // finds the local rule store
           // sqlrs = dd.GetRuleStore();
            // get the ruleset -- it has links to the vocabulary
           // RuleSet rfpRules = sqlrs.GetRuleSet(rsInfo);
            // configure with an instance of our database fact retriever
            //RuleSetExecutionConfiguration exConfig = new RuleSetExecutionConfiguration();
            //RuleEngineComponentConfiguration dbconfig= new RuleEngineComponentConfiguration("DbFactRetriever","Que.BizTalk.RFP.myFactRetriever.RFPDbFactRetriever");
            //exConfig.FactRetriever = dbconfig;
            //rfpRules.ExecutionConfiguration = exConfig;
            
            // load the doc containing RFP facts

            XmlDocument doc = new XmlDocument();
            doc.Load("sample_rfp.xml");

            // The name has to match the qualified name the ruleset expects
            TypedXmlDocument RFPDoc = new TypedXmlDocument("RFPEstimateXML.RulesRFP", doc);

            // instantiate a policy tester and execute with an XML document containing facts
            //PolicyTester host = new PolicyTester(rfpRules);
            Policy host = new Policy("RFP");
            host.Execute(RFPDoc);

            // the document has been changed -- write it out
            FileInfo finfo = new FileInfo("ProcessedRFP.xml");
            StreamWriter writer = finfo.CreateText();
            writer.Write(RFPDoc.Document.OuterXml);
            writer.Close();
         }
         catch (Exception e) 
         {
            System.Console.WriteLine(e.ToString());
         }

		}
	}
}
