using System;
using System.Management;


namespace WMI
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class CreateStartReceiveSendPort
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			ManagementObject ReceivePort_objInstance,ReceiveLocation_objInstance,SendPort_objInstance  = null;

			try
			{
//Create Receive Port

				ManagementClass ReceivePort_objClass = new ManagementClass(@"root\MicrosoftBizTalkServer","MSBTS_ReceivePort", new ObjectGetOptions());
				ReceivePort_objInstance = ReceivePort_objClass.CreateInstance();
				ReceivePort_objInstance.SetPropertyValue("Name","ReceivePort_Chapter17");
				ReceivePort_objInstance.SetPropertyValue("IsTwoWay",false);
				ReceivePort_objInstance.Put();
				Console.WriteLine("Receive Port created.");

 //Create and Enable Receive Location and
				ManagementClass ReceiveLocation_objClass = new ManagementClass(@"root\MicrosoftBizTalkServer","MSBTS_ReceiveLocation", new ObjectGetOptions());
				ReceiveLocation_objInstance = ReceiveLocation_objClass.CreateInstance();
				ReceiveLocation_objInstance.SetPropertyValue("Name","Receivelocation_Chapter17");
				ReceiveLocation_objInstance.SetPropertyValue("AdapterName","FILE");
				ReceiveLocation_objInstance.SetPropertyValue("HostName","BizTalkServerApplication");
				ReceiveLocation_objInstance.SetPropertyValue("InboundTransportURL",@"C:\Temp\*.xml");
				ReceiveLocation_objInstance.SetPropertyValue("PipelineName","Microsoft.BizTalk.DefaultPipelines.XMLReceive, Microsoft.BizTalk.DefaultPipelines, Version=3.0.1.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35");
				ReceiveLocation_objInstance.SetPropertyValue("ReceivePortName","ReceivePort_Chapter17");
				ReceiveLocation_objInstance.Put();
				ReceiveLocation_objInstance.InvokeMethod("Enable",null);
				Console.WriteLine("Receive Location created and Enabled.");
				
//Create Send Port
				ManagementClass SendPort_objClass = new ManagementClass(@"root\MicrosoftBizTalkServer","MSBTS_SendPort", new ObjectGetOptions());
				SendPort_objInstance = SendPort_objClass.CreateInstance();
				SendPort_objInstance.SetPropertyValue("Name","SendPort_Chapter17");
				SendPort_objInstance.SetPropertyValue("IsTwoWay",false);
				SendPort_objInstance.SetPropertyValue("IsDynamic",false);
				SendPort_objInstance.SetPropertyValue("PTAddress",@"C:\Inxcv\%MessageId%.xml%");
				SendPort_objInstance.SetPropertyValue("PTTransportType","FILE");
				SendPort_objInstance.SetPropertyValue("SendPipeline","Microsoft.BizTalk.DefaultPipelines.PassThruTransmit, Microsoft.BizTalk.DefaultPipelines, Version=3.0.1.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35");
				SendPort_objInstance.SetPropertyValue("PTRetryCount",1);
				SendPort_objClass.SetPropertyValue("PTRetryInterval",1);
				SendPort_objInstance.SetPropertyValue("Filter",@"<Filter><Group><Statement Property='BTS.ReceivePortName' Operator='0' Value='ReceivePort_Chapter17'/></Group><Group/></Filter>");
				SendPort_objInstance.SetPropertyValue("PTServiceWindowEnabled",false);
				SendPort_objInstance.Put();
				SendPort_objInstance.InvokeMethod("Enlist",null);
				SendPort_objInstance.InvokeMethod("Start",null);
				Console.WriteLine("Send Port created and started.");
				Console.Write("Please Enter to Finish.");
				Console.ReadLine();




				
			}
			catch(Exception e)
			{
				System.Diagnostics.EventLog.WriteEntry("WMIAddAdapter",e.Message,System.Diagnostics.EventLogEntryType.Error);

			}
		}
	}
}
